<html lang="en">
<head>
<title>CLOS compatibility - Enhanced Implementation of Emacs Interpreted Objects</title>
<meta http-equiv="Content-Type" content="text/html">
<meta name="description" content="Enhanced Implementation of Emacs Interpreted Objects">
<meta name="generator" content="makeinfo 4.8">
<link title="Top" rel="start" href="index.html#Top">
<link rel="prev" href="Introduction.html#Introduction" title="Introduction">
<link rel="next" href="Building-Classes.html#Building-Classes" title="Building Classes">
<link href="http://www.gnu.org/software/texinfo/" rel="generator-home" title="Texinfo Homepage">
<meta http-equiv="Content-Style-Type" content="text/css">
<style type="text/css"><!--
  pre.display { font-family:inherit }
  pre.format  { font-family:inherit }
  pre.smalldisplay { font-family:inherit; font-size:smaller }
  pre.smallformat  { font-family:inherit; font-size:smaller }
  pre.smallexample { font-size:smaller }
  pre.smalllisp    { font-size:smaller }
  span.sc    { font-variant:small-caps }
  span.roman { font-family:serif; font-weight:normal; } 
  span.sansserif { font-family:sans-serif; font-weight:normal; } 
--></style>
</head>
<body>
<div class="node">
<p>
<a name="CLOS-compatibility"></a>
Next:&nbsp;<a rel="next" accesskey="n" href="Building-Classes.html#Building-Classes">Building Classes</a>,
Previous:&nbsp;<a rel="previous" accesskey="p" href="Introduction.html#Introduction">Introduction</a>,
Up:&nbsp;<a rel="up" accesskey="u" href="index.html#Top">Top</a>
<hr>
</div>

<!-- node-name,  next,  previous,  up -->
<h2 class="chapter">2 CLOS compatibility</h2>

<p>As you read this, it is important to know that I have just recently
learned some of the CLOS syntax, but have never used it myself outside
of the EIEIO framework.  I'm primarily and Emacs Lisp hacker who wrote
EIEIO to help myself learn some of the mechanics of Object Oriented
programming.

   <p>Currently, the following functions should behave almost as expected from
CLOS.

     <dl>
<dt><code>defclass</code><dd>All slot keywords are available but not all work correctly. 
Slot keyword differences are:

          <dl>
<dt>:reader, and :writer tags<dd>Create methods that throw errors instead of creating an unqualified
method.  You can still create new ones to do its business. 
<br><dt>:accessor<dd>This should create an unqualified method to access a slot, but
instead pre-builds a method that gets the slot's value. 
<br><dt>:type<dd>Specifier uses the <code>typep</code> function from the <samp><span class="file">cl</span></samp>
package.  See <a href="../cl/Type-Predicates.html#g_t_0028cl_0029Type-Predicates">(cl)Type Predicates</a>. It therefore has the same issues as
that package.  Extensions include the ability to provide object names. 
</dl>

     <p>Defclass also supports class options, but does not currently use values
of <code>:metaclass</code>, and <code>:default-initargs</code>.

     <br><dt><code>make-instance</code><dd>Make instance works as expected, however it just uses the EIEIO instance
creator automatically generated when a new class is created. 
See <a href="Making-New-Objects.html#Making-New-Objects">Making New Objects</a>. 
<br><dt><code>defgeneric</code><dd>Creates the desired symbol, and accepts all of the expected arguments
except <code>:AROUND</code>. 
<br><dt><code>defmethod</code><dd>Calls defgeneric, and accepts most of the expected arguments.  Only the
first argument to the created method may be type cast, though any
argument can be syntactically type cast.  (And promptly ignored)  To
type cast against a class, the class must exist before defmethod is
called. In addition, the <code>:AROUND</code> tag is not supported. 
<br><dt><code>call-next-method</code><dd>Inside a method, calls the next available method up the inheritance tree
for the given object.  This is different than that found in CLOS because
in EIEIO this function accepts replacement arguments.  This permits
subclasses to modify arguments as they are passed up the tree.  If no
arguments are given, the expected CLOS behavior is used. 
<br><dt><code>setf</code><dd>If the common-lisp subsystem is loaded, the setf parameters are also
loaded so the form <code>(setf (slot-value object slot) t)</code> should
work. 
</dl>

   <p>CLOS supports the <code>describe</code> command, but eieio only provides
<code>eieio-describe-class</code>, and <code>eieio-describe-generic</code>.  These
functions are adviced into <code>describe-variable</code>, and
<code>describe-function</code>.

   <p>When creating a new class (see <a href="Building-Classes.html#Building-Classes">Building Classes</a>) there are several
new keywords supported by EIEIO.

   <p>In EIEIO tags are in lower case, not mixed case.

   </body></html>

